package com.wdkl.ncs.android.middleware.api

import com.wdkl.ncs.android.lib.base.BaseApplication
import com.wdkl.ncs.android.middleware.config.WdklNcsConfigCenter
import com.wdkl.ncs.android.middleware.utils.CommonUtils

/**
 * @author LDD
 * @Date   2018/8/21 下午4:38
 * @From   com.wdkl.ncs.android.middleware.api
 * @Note   Url控制器接口
 */
interface UrlManager {

    /// host地址
    val base  : String

    /// 设备Api
    val device_url : String

    /// 基础Api
    val basic : String

    /**
     * @author LDD
     * @Date   2018/8/21 下午4:46
     * @From   UrlManager
     * @Note   伴生对象
     */
    companion object {

        /**
         * @author LDD
         * @From   UrlManager
         * @Date   2018/8/21 下午4:47
         * @Note   构架Url控制器
         */
        fun build() : UrlManager{
            /*return if (WdklNcsConfigCenter.INSTANCE.APP_DEV){
                return DevUrlManager()
            }else{
                return ProUrlManager()
            }*/

            return DevUrlManager()
        }

    }

}

/**
 * @author LDD
 * @Date   2018/8/21 下午4:38
 * @From   com.wdkl.ncs.android.middleware.api
 * @Note   开发模式Url控制器
 */
private class DevUrlManager : UrlManager{
    val url: String = CommonUtils.getUrl(BaseApplication.appContext)
    val port: String = CommonUtils.getUrlPort(BaseApplication.appContext)

    override val base: String
        get() = "http://${url}"

        //get() = "http://dev.base.wdklian.com"
        //get() = "http://8.129.220.143"
        //get() = "http://119.23.151.229"

        //get() = "http://192.168.1.188"
        //get() = "http://120.76.246.253"

    override val device_url: String
        get() = "http://$url:$port/"

        //get() = "${base}:6005/"
        //get() = "${base}:8006/"
    override val basic: String
        get() = "${base}:7002/"
}

/**
 * @author LDD
 * @Date   2018/8/21 下午4:38
 * @From   com.wdkl.ncs.android.middleware.api
 * @Note   生产模式Url控制器
 */
private class ProUrlManager : UrlManager{

    override val base: String
        get() = "http://8.129.220.143"

    override val device_url: String
        get() = String.format(base,"device_url")

    override val basic: String
        get() = String.format(base,"base")
}