package com.wdkl.ncs.android.middleware.config

import com.wdkl.ncs.android.lib.base.BaseApplication
import com.wdkl.ncs.android.lib.utils.AppTool
import org.json.JSONObject

/**
 * @author LDD
 * @Date   2018/5/18 上午11:15
 * @From   com.wdkl.ncs.android.middleware.config
 * @Note   配置中心
 */
class WdklNcsConfigCenter {

    /**
     * @Name  jsonObject
     * @Type  JSONObject
     * @Note  Json对象
     */
    val jsonObject :JSONObject = JSONObject(AppTool.File.readAssetsText(BaseApplication.appContext,"config.wdkl"))

    /**
     *  是否处于开发模式
     */
    val APP_DEV = true

    /**
     * 基础URL
     */
    val WAP_BASE_URL = "http://192.168.1.188/"

    /**
     * 店铺页面URL
     */
    val WAP_SELLER_URL = "${WAP_BASE_URL}shop/"

    /**
     * @author LDD
     * @Date   2018/5/18 上午11:18
     * @From   JavaShopConfigCenter
     * @Note   伴生对象
     */
    companion object {

        /**
         * @Name  com.wdkl.ncs.android.middleware.config.JavaShopConfigCenter.Companion.INSTANCE
         * @Type  JavaShopConfigCenter
         * @Note  配置中心单例
         */
        @JvmStatic val INSTANCE by lazy { WdklNcsConfigCenter()}

    }

}