package com.wdkl.ncs.android.middleware.logic.contract.home

import com.wdkl.ncs.android.lib.base.BaseContract
import com.wdkl.ncs.android.middleware.model.ServerIpInfo
import com.wdkl.ncs.android.middleware.model.dos.AppVersionDO
import com.wdkl.ncs.android.middleware.model.dos.DeviceDO
import com.wdkl.ncs.android.middleware.model.dos.PartSettingDO
import com.wdkl.ncs.android.middleware.model.dto.TcpSeverDTO
import com.wdkl.ncs.android.middleware.model.vo.DeviceVO
import com.wdkl.ncs.android.middleware.model.vo.DeviceWatchInfoVO
import com.wdkl.ncs.android.middleware.model.vo.WatchContactsVO

interface HomeActivityContract{
    interface View : BaseContract.BaseView{
        //显示设备信息
        fun setDeviceDo(data : DeviceWatchInfoVO)
        //显示tcp通讯地址
        fun setTcpServerHost(tcpSeverDTO: TcpSeverDTO)
        fun setServerInfo(serverIpInfo: ServerIpInfo)
        //设置设备设置数据
        fun setDeviceSettingData(partSettingDO: PartSettingDO)
    }
    interface Presenter : BaseContract.BasePresenter{
        //获取设备信息
        fun getDeviceVO(ethMac:String)
        //获取tcp服务器地址
        fun getTcpServerHost()
        fun getServerInfo()
        //获取设备设置数据
        fun getDeviceSettingData(partId:Int)
    }
}