package com.wdkl.ncs.android.middleware.logic.contract.home

import com.wdkl.ncs.android.lib.base.BaseContract
import com.wdkl.ncs.android.middleware.model.dos.BroadcastDO
import com.wdkl.ncs.android.middleware.model.dos.DeviceDO
import com.wdkl.ncs.android.middleware.model.dto.TcpSeverDTO
import com.wdkl.ncs.android.middleware.model.vo.DeviceVO

/**
 * 获取当前设备数据接口
 */
interface WatchDeviceContract {
    /**
     * 显示当前设备数据
     */
    interface View: BaseContract.BaseView{
        //显示设备信息
        fun showData(data : DeviceVO)
        //显示tcp通讯地址
        fun setTcpServerHost(tcpSeverDTO: TcpSeverDTO)
    }

    /**
     * 获取当前设备数据
     */
  interface Presenter:BaseContract.BasePresenter{
        //获取设备信息
        fun loadData(ethMac:String)
        //获取tcp服务器地址
        fun loadTcpServerHost()
  }


}