package com.wdkl.ncs.android.middleware.tcp.channel;

import com.wdkl.ncs.android.middleware.model.vo.InteractionVO;
import com.wdkl.ncs.android.middleware.tcp.TcpClient;
import com.wdkl.ncs.android.middleware.tcp.dto.TcpModel;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpAction;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpType;

import java.util.HashMap;
import java.util.Map;

public class VoiceUtil {
    //护士呼叫 不要toId
    public static TcpModel voiceCall(Integer fromId, Integer toId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.CALL);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        return tcpModel;
    }

    public static TcpModel voiceCall(Integer fromId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.CALL);
        tcpModel.setFromId(fromId);
        return tcpModel;
    }

    //营养师 管家呼叫 要toId
//    public static TcpModel voiceCall(Integer fromId, Integer toId){
//        TcpModel tcpModel = new TcpModel();
//        tcpModel.setType(TcpType.VOICE);
//        tcpModel.setAction(TcpAction.VoiceAction.CALL);
//        tcpModel.setFromId(fromId);
//        tcpModel.setToId(toId);
//        return tcpModel;
//    }

    public static TcpModel voiceAccept(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.ACCEPT);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceReject(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.REJECT);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceCalling(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.CALLING);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceCancel(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
//        tcpModel.setType(TcpType.VOICE);
//        tcpModel.setAction(TcpAction.VoiceAction.CANCEL);
//        tcpModel.setFromId(fromId);
//        tcpModel.setToId(toId);
        return tcpModel;
    }

    public static TcpModel voiceHandoff(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.HANDOFF);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceSuccess(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.SUCCESS);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceFailed(Integer fromId, Integer toId,Integer InteractionId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.FAILED);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        tcpModel.setData(InteractionId);
        return tcpModel;
    }

    public static TcpModel voiceTransfer(Integer fromId, Integer toId, Object interactionVO){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.VOICE);
        tcpModel.setAction(TcpAction.VoiceAction.TRANSFER);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        Map map = new HashMap<String,String>();
        map.put("deviceId",toId);
        map.put("interactionVo",interactionVO);
        tcpModel.setData(map);
        return tcpModel;
    }



    //语音呼叫
    public static void startAudioCall(Integer fromId) {
        TcpModel tcpModel = VoiceUtil.voiceCall(fromId);
        TcpClient.getInstance().sendMsg(tcpModel.toJson());
    }
}
